;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_set
  (foreign (include #"caml-bigloo.h"))
  (import)
  (export
    (empty_102@set x1)
    (is_empty_204@set x1)
    (mem_169@set x1)
    (2-66-mem_169@set x1 x2)
    (add_6@set x1)
    (2-72-add_6@set x1 x2)
    (remove_141@set x1)
    (2-157-remove_141@set x1 x2)
    (union_3@set x1)
    (2-80-union_3@set x1 x2)
    (inter_153@set x1)
    (2-9-inter_153@set x1 x2)
    (diff_72@set x1)
    (2-173-diff_72@set x1 x2)
    (compare_121@set x1)
    (2-255-compare_121@set x1 x2)
    (equal_60@set x1)
    (2-246-equal_60@set x1 x2)
    (iter_219@set x1)
    (2-173-iter_219@set x1 x2)
    (fold_73@set x1)
    (3-37-fold_73@set x1 x2 x3)
    (elements_188@set x1)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(define empty_102@set
  (lambda (x1)
    (caml-make-regular
      (caml-make-tag 0 0)
      2
      (caml-make-tag 0 2)
      x1)))

(define is_empty_204@set
  (lambda (x1)
    (let ((x2 (caml-constr-get-field x1 0)))
      (labels
        ((staticfail1000 () #f))
        (let ((:-d.1001 x2))
          (cond ((eq? :-d.1001 (caml-make-tag 0 2)) #t)
                (else (staticfail1000))))))))

(begin
  (define mem_169@set
    (lambda (x1)
      (lambda (x2) (2-66-mem_169@set x1 x2))))
 (define 2-66-mem_169@set
    (lambda (x1 x2)
      ((contains_14@baltree
         ((caml-constr-get-field x2 1) x1))
       (caml-constr-get-field x2 0))))
)
(begin
  (define add_6@set
    (lambda (x1)
      (lambda (x2) (2-72-add_6@set x1 x2))))
 (define 2-72-add_6@set
    (lambda (x1 x2)
      (caml-make-regular
        (caml-make-tag 0 0)
        2
        (((add_6@baltree ((caml-constr-get-field x2 1) x1))
          x1)
         (caml-constr-get-field x2 0))
        (caml-constr-get-field x2 1))))
)
(begin
  (define remove_141@set
    (lambda (x1)
      (lambda (x2) (2-157-remove_141@set x1 x2))))
 (define 2-157-remove_141@set
    (lambda (x1 x2)
      (caml-make-regular
        (caml-make-tag 0 0)
        2
        ((remove_141@baltree
           ((caml-constr-get-field x2 1) x1))
         (caml-constr-get-field x2 0))
        (caml-constr-get-field x2 1))))
)
(begin
  (define union_3@set
    (lambda (x1)
      (lambda (x2) (2-80-union_3@set x1 x2))))
 (define 2-80-union_3@set
    (lambda (x1 x2)
      (letrec ((x3 (lambda (x4)
                     (lambda (x5)
                       (labels
                         ((staticfail1002
                            ()
                            (raise (caml-make-extensible
                                     'match_failure_1@builtin
                                     3
                                     #"Mlib/set.ml"
                                     560
                                     743))))
                         (labels
                           ((staticfail1003
                              ()
                              (labels
                                ((staticfail1004
                                   ()
                                   (case (if (caml-constant-constr? x4)
                                           -1
                                           (caml-regular-constr-tag x4))
                                     ((2)
                                      (let ((x6 ((split_219@baltree
                                                   ((caml-constr-get-field x1 1)
                                                    (caml-constr-get-field
                                                      x4
                                                      1)))
                                                 x5)))
                                        (((join_132@baltree
                                            ((x3 (caml-constr-get-field x4 0))
                                             (caml-constr-get-field x6 0)))
                                          (caml-constr-get-field x4 1))
                                         ((x3 (caml-constr-get-field x4 2))
                                          (caml-constr-get-field x6 2)))))
                                     (else (staticfail1002)))))
                                (let ((:-d.1005 x5))
                                  (cond ((eq? :-d.1005 (caml-make-tag 0 2)) x4)
                                        (else (staticfail1004)))))))
                           (let ((:-d.1006 x4))
                             (cond ((eq? :-d.1006 (caml-make-tag 0 2)) x5)
                                   (else (staticfail1003))))))))))
        (caml-make-regular
          (caml-make-tag 0 0)
          2
          ((x3 (caml-constr-get-field x1 0))
           (caml-constr-get-field x2 0))
          (caml-constr-get-field x1 1)))))
)
(begin
  (define inter_153@set
    (lambda (x1)
      (lambda (x2) (2-9-inter_153@set x1 x2))))
 (define 2-9-inter_153@set
    (lambda (x1 x2)
      (letrec ((x3 (lambda (x4)
                     (lambda (x5)
                       (labels
                         ((staticfail1007
                            ()
                            (raise (caml-make-extensible
                                     'match_failure_1@builtin
                                     3
                                     #"Mlib/set.ml"
                                     839
                                     1138))))
                         (labels
                           ((staticfail1008
                              ()
                              (labels
                                ((staticfail1009
                                   ()
                                   (case (if (caml-constant-constr? x4)
                                           -1
                                           (caml-regular-constr-tag x4))
                                     ((2)
                                      (let ((x6 ((split_219@baltree
                                                   ((caml-constr-get-field x1 1)
                                                    (caml-constr-get-field
                                                      x4
                                                      1)))
                                                 x5)))
                                        (let ((:-d.1010
                                                (caml-constr-get-field x6 1)))
                                          (cond ((eq? :-d.1010
                                                      (caml-make-tag 0 2))
                                                 ((concat_228@baltree
                                                    ((x3 (caml-constr-get-field
                                                           x4
                                                           0))
                                                     (caml-constr-get-field
                                                       x6
                                                       0)))
                                                  ((x3 (caml-constr-get-field
                                                         x4
                                                         2))
                                                   (caml-constr-get-field
                                                     x6
                                                     2))))
                                                (else
                                                 (((join_132@baltree
                                                     ((x3 (caml-constr-get-field
                                                            x4
                                                            0))
                                                      (caml-constr-get-field
                                                        x6
                                                        0)))
                                                   (caml-constr-get-field x4 1))
                                                  ((x3 (caml-constr-get-field
                                                         x4
                                                         2))
                                                   (caml-constr-get-field
                                                     x6
                                                     2))))))))
                                     (else (staticfail1007)))))
                                (let ((:-d.1011 x5))
                                  (cond ((eq? :-d.1011 (caml-make-tag 0 2))
                                         (caml-make-tag 0 2))
                                        (else (staticfail1009)))))))
                           (let ((:-d.1012 x4))
                             (cond ((eq? :-d.1012 (caml-make-tag 0 2))
                                    (caml-make-tag 0 2))
                                   (else (staticfail1008))))))))))
        (caml-make-regular
          (caml-make-tag 0 0)
          2
          ((x3 (caml-constr-get-field x1 0))
           (caml-constr-get-field x2 0))
          (caml-constr-get-field x1 1)))))
)
(begin
  (define diff_72@set
    (lambda (x1)
      (lambda (x2) (2-173-diff_72@set x1 x2))))
 (define 2-173-diff_72@set
    (lambda (x1 x2)
      (letrec ((x3 (lambda (x4)
                     (lambda (x5)
                       (labels
                         ((staticfail1013
                            ()
                            (raise (caml-make-extensible
                                     'match_failure_1@builtin
                                     3
                                     #"Mlib/set.ml"
                                     1232
                                     1524))))
                         (labels
                           ((staticfail1014
                              ()
                              (labels
                                ((staticfail1015
                                   ()
                                   (case (if (caml-constant-constr? x4)
                                           -1
                                           (caml-regular-constr-tag x4))
                                     ((2)
                                      (let ((x6 ((split_219@baltree
                                                   ((caml-constr-get-field x1 1)
                                                    (caml-constr-get-field
                                                      x4
                                                      1)))
                                                 x5)))
                                        (let ((:-d.1016
                                                (caml-constr-get-field x6 1)))
                                          (cond ((eq? :-d.1016
                                                      (caml-make-tag 0 2))
                                                 (((join_132@baltree
                                                     ((x3 (caml-constr-get-field
                                                            x4
                                                            0))
                                                      (caml-constr-get-field
                                                        x6
                                                        0)))
                                                   (caml-constr-get-field x4 1))
                                                  ((x3 (caml-constr-get-field
                                                         x4
                                                         2))
                                                   (caml-constr-get-field
                                                     x6
                                                     2))))
                                                (else
                                                 ((concat_228@baltree
                                                    ((x3 (caml-constr-get-field
                                                           x4
                                                           0))
                                                     (caml-constr-get-field
                                                       x6
                                                       0)))
                                                  ((x3 (caml-constr-get-field
                                                         x4
                                                         2))
                                                   (caml-constr-get-field
                                                     x6
                                                     2))))))))
                                     (else (staticfail1013)))))
                                (let ((:-d.1017 x5))
                                  (cond ((eq? :-d.1017 (caml-make-tag 0 2)) x4)
                                        (else (staticfail1015)))))))
                           (let ((:-d.1018 x4))
                             (cond ((eq? :-d.1018 (caml-make-tag 0 2))
                                    (caml-make-tag 0 2))
                                   (else (staticfail1014))))))))))
        (caml-make-regular
          (caml-make-tag 0 0)
          2
          ((x3 (caml-constr-get-field x1 0))
           (caml-constr-get-field x2 0))
          (caml-constr-get-field x1 1)))))
)
(begin
  (define compare_121@set
    (lambda (x1)
      (lambda (x2) (2-255-compare_121@set x1 x2))))
 (define 2-255-compare_121@set
    (lambda (x1 x2)
      (((compare_121@baltree
          (caml-constr-get-field x1 1))
        (caml-constr-get-field x1 0))
       (caml-constr-get-field x2 0))))
)
(begin
  (define equal_60@set
    (lambda (x1)
      (lambda (x2) (2-246-equal_60@set x1 x2))))
 (define 2-246-equal_60@set
    (lambda (x1 x2)
      (eq? ((compare_121@set x1) x2) 0)))
)
(begin
  (define iter_219@set
    (lambda (x1)
      (lambda (x2) (2-173-iter_219@set x1 x2))))
 (define 2-173-iter_219@set
    (lambda (x1 x2)
      (letrec ((x3 (lambda (x4)
                     (let ((:-d.1019 x4))
                       (cond ((eq? :-d.1019 (caml-make-tag 0 2))
                              (caml-make-tag 0 1))
                             (else
                              (begin
                                (x3 (caml-constr-get-field x4 0))
                                (begin
                                  (x1 (caml-constr-get-field x4 1))
                                  (x3 (caml-constr-get-field x4 2))))))))))
        (x3 (caml-constr-get-field x2 0)))))
)
(begin
  (define fold_73@set
    (lambda (x1)
      (lambda (x2)
        (lambda (x3) (3-37-fold_73@set x1 x2 x3)))))
 (define 3-37-fold_73@set
    (lambda (x1 x2 x3)
      (letrec ((x4 (lambda (x5)
                     (lambda (x6)
                       (let ((:-d.1020 x6))
                         (cond ((eq? :-d.1020 (caml-make-tag 0 2)) x5)
                               (else
                                ((x4 ((x1 (caml-constr-get-field x6 1))
                                      ((x4 x5) (caml-constr-get-field x6 2))))
                                 (caml-constr-get-field x6 0)))))))))
        ((x4 x3) (caml-constr-get-field x2 0)))))
)
(define elements_188@set
  (lambda (x1)
    (letrec ((x2 (lambda (x3)
                   (lambda (x4)
                     (let ((:-d.1021 x4))
                       (cond ((eq? :-d.1021 (caml-make-tag 0 2)) x3)
                             (else
                              ((x2 (cons (caml-constr-get-field x4 1)
                                         ((x2 x3)
                                          (caml-constr-get-field x4 2))))
                               (caml-constr-get-field x4 0)))))))))
      ((x2 '()) (caml-constr-get-field x1 0)))))

